#include "Depot.h"

Depot::Depot() {

	_name = "";
}

Depot::~Depot(void)
{
	_storages.clear();
}

void Depot::SetName(string name)  {

	_name = name;
}

string Depot::GetName() {

	return _name;
}

void Depot::AddStorage(StoragePtr storage) {

	_storages.push_back(storage);
}

int Depot::GetStorageCount() {

	return _storages.size();
}

StoragePtr Depot::GetStorage(int index) {

	if (index >= 0 && index < _storages.size()) {
		return _storages.at(index);
	} else {
		return Storage::Null;
	}
}

StoragePtr Depot::GetStorage(const string& productId) {

	for (vector<StoragePtr>::iterator iter = _storages.begin(); iter != _storages.end(); ++iter) {
		if ((*iter)->GetProduct()->GetId().compare(productId) == 0) {
			return *iter;
		}
	}
	return Storage::Null;
}