#pragma once

#include "Common.h"
#include "Utils.h"
#include "Depot.h"

typedef union {
	struct {
		double lng, lat, hdg;
	};
} ExpositionBase;

class DepotBase : public virtual Depot {

public:
	DepotBase();
	DepotBase(OBJHANDLE cBody);
	~DepotBase();

	static DepotBasePtr Create(OBJHANDLE cBody);
	static DepotBasePtr Null;

	void SetCBody(OBJHANDLE cBody);

	void SetBaseName(string baseName);
	string GetBaseName();

	void AddStorage(StoragePtr storage, ExpositionBase exposition);

	int Unload(const int& storageIndex, const int& amount, char* customName);
	bool Load(const int& storageIndex);

private:

	OBJHANDLE _cBody;

	string _baseName;

	// keys - product ids
	map<string, ExpositionBase> _expositions;
};

