#pragma once

#include "Common.h"
#include "Utils.h"
#include "DepotBase.h"

static const int RESOURCE_CHECK_INTERVAL = 5;

class Plant : public virtual Depot
{
public:
	Plant();
	~Plant(void);

	virtual bool IsPlant() {return true;}

	void SetProduct(ProductPtr product) {_product = product;};
	ProductPtr GetProduct() {return _product;};

	void Produce(double simdt);

	void SetRate(double rate);

	void SetProgress(double progress);
	float GetProgress();

	bool InProduction();
	double GetRemainingTime();

private:

	ProductPtr _product;

	// constant params
	double _rate;
	double _rateInSec;

	// variable params
	double _progress;

	double _resourceCheckDt;

	bool StartNewProduction();
};

