#include "PlantBase.h"


PlantBase::PlantBase(void) : Plant(), DepotBase()
{
}

PlantBase::PlantBase(OBJHANDLE cBody) : Plant(), DepotBase(cBody) {

}

PlantBase::~PlantBase(void)
{
}

PlantBasePtr PlantBase::Create(OBJHANDLE cBody) {

#ifdef USE_SMART_PTRS
	return make_shared<PlantBase>(cBody);
#else
	return new PlantBase(cBody);
#endif
}

#ifdef USE_SMART_PTRS
PlantBasePtr PlantBase::Null = PlantBasePtr();
#else
PlantBasePtr PlantBase::Null = NULL;
#endif

PlantBasePtr PlantBase::Cast(DepotBasePtr depotBase) {

#ifdef USE_SMART_PTRS
	return dynamic_pointer_cast<PlantBase>(depotBase);
#else
	return dynamic_cast<PlantBasePtr>(depotBase);
#endif
}
