#pragma once

#include "Common.h"

class Product
{
public:

	Product(void);
	~Product(void);

	static ProductPtr Create();
	static ProductPtr Null;

	void SetId(string id) {_id = id;};
	string GetId() {return _id;};

	void SetName(string name) {_name = name;};
	string GetName() {return _name;};

	void SetType(string type) {_type = type;};
	string GetType() {return _type;};

	void SetVessel(string vessel) {_vessel = vessel;};
	string GetVessel() {return _vessel;};

	void SetSlotLength(double slot_length) {_slot_length = slot_length;};
	double GetSlotLength() {return _slot_length;};

	void SetSlotWidth(double slot_width) {_slot_width = slot_width;};
	double GetSlotWidth() {return _slot_width;};

	void AddResource(string productId, int requiredAmount) {_resources[productId] = requiredAmount;};
	map<string, int>& GetResources() {return _resources;};

private:

	string _id;
	string _name;
	string _type;
	string _vessel;

	double _slot_length;
	double _slot_width;

	// key - product id, value - required amount
	map<string, int> _resources;
};
