#include "Storage.h"

Storage::Storage(void) {

	_capacity = 0;
	_stored = 0;
}

Storage::~Storage(void) {

}

StoragePtr Storage::Create() {

#ifdef USE_SMART_PTRS
	return make_shared<Storage>();
#else
	return new Storage();
#endif
}

#ifdef USE_SMART_PTRS
StoragePtr Storage::Null = StoragePtr();
#else
StoragePtr Storage::Null = NULL;
#endif

void Storage::Add(int amount) {

	_stored += min(amount, _capacity - _stored);
}

void Storage::Remove(int amount) {

	_stored -= amount;
	_stored = max(_stored, 0);
}

bool Storage::IsFull() {

	return _stored >= _capacity;
}
