#pragma once

#include "Common.h"
#include "Product.h"

class Storage
{
public:

	Storage(void);
	~Storage(void);

	static StoragePtr Create();
	static StoragePtr Null;

	void SetProduct(ProductPtr product) {_product = product;};
	ProductPtr GetProduct() {return _product;};

	void SetDefaultVesselName(string defaultVesselName) {_defaultVesselName = defaultVesselName;};
	string GetDefaultVesselName() {return _defaultVesselName;};

	void SetCapacity(int capacity) {_capacity = capacity;};
	int GetCapacity() {return _capacity;};

	void SetStored(int stored) {_stored = stored;};
	int GetStored() {return _stored;};

	void Add(int amount);
	void Remove(int amount);

	bool IsFull();

private:

	ProductPtr _product;
	string _defaultVesselName;
	int _capacity;
	int _stored;
};

